package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.util.*;

import java.util.*;

/**
 * A PolyJClassType represents classes that might also be polymorphic, i.e. classes
 * that could be instantiated.  Currently, all class are represented using this.
 */
public interface PolyJClassType extends ClassType, PolyTypeOps { 
    /**
     * Wrap the type in a lazy transformer.
     * See PolyJTypeWrapper.
     */
    WrappedClassType wrap(ClassType oldEnclosingType, ClassType newEnclosingType, PolyJTypeWrapper tw);
}
