package polyglot.ext.polyj.types;

import polyglot.frontend.*;
import polyglot.types.*;

import polyglot.ext.polyj.ast.*;

import polyglot.ext.jl.types.*;

import java.util.*;

public class PolyJParsedClassType_c extends ParsedClassType_c implements PolyJParsedClassType
{
    protected PolyDlg dlg;

    public PolyJParsedClassType_c(TypeSystem ts, LazyClassInitializer init, 
                                  Source fromSource)
    {
        super(ts, init, fromSource);
        dlg = ((PolyJTypeSystem)ts).PolyDlg(this);
    }

    public List params() {
        return dlg.params();
    }

    public ParamType paramNamed(String name) {
        return dlg.paramNamed(name);
    }

    public boolean isPolymorphic() {
        return dlg.isPolymorphic();
    }

    public void addParam(String paramName) {
        dlg.addParam(paramName);
    }

    public void addConstraint(ClassConstraint c) throws SemanticException {
        dlg.addConstraint(c);
    }
    
    public WrappedClassType wrap(ClassType oldEnclosingType, ClassType newEnclosingType, PolyJTypeWrapper tw) {
        return new WrappedPolyJParsedClassType_c(this, oldEnclosingType, newEnclosingType, tw);
    }    
}
