package polyglot.ext.polyj.types;

import polyglot.types.*;
import polyglot.util.*;

import polyglot.ext.jl.types.*;
import polyglot.ext.polyj.ast.*;
import polyglot.ext.polyj.visit.*;

import java.util.*;

/**
 * The operations that all WrappedTypes need to implement differently than
 * their superclass, and some operations that only wrapped types support.
 */
interface WrappedTypeOps {
    // Different implementations
    ClassType.Kind kind();
    List methods();
    List constructors();
    MethodInstance originalMethod(MethodInstance mi);
    ConstructorInstance originalConstructor(ConstructorInstance ci);
    List fields();
    Type superType();
    List interfaces();
    String fullName();
    String name();
    polyglot.types.Package package_();
    Flags flags();
    boolean isNested();
    boolean isLocal();
    boolean isAnonymous();
    ClassType outer();
    List memberClasses();
    ClassType memberClassNamed(String name);
    String translate(Resolver c);

    // Operations on WrappedTypes
    ClassType wrappedClass();
    List args();
    PolyJTypeWrapper substitutor();
}
