package polyglot.ext.polyj.types.proxy;

/**
 * This is approximately the class that is created as a proxy
 * for array instantiations.  It differs on a few methods
 * whose types are not representable in plain Java.
 *
 * Note that this class is actually never used... it's just here
 * to document what PolyJ generates at compile time.
 */
public abstract class ArrayProxy implements Cloneable, java.io.Serializable {
    public ArrayProxy(int s) { }

    public abstract Object clone();
    public abstract int size();

    /**
     * Actually takes ArrayProxy[E], where E is the element type.
     */
    public ArrayProxy(ArrayProxy a) { }

    /**
     * Actually takes E[], not Object[], where E is the
     * element type.
     */
    public ArrayProxy(Object[] a) { }

    /**
     * Actually returns E, not Object, where E is the element type.
     */
    public abstract Object get(int i);

    /**
     * Actually takes E, not Object, where E is the element type.
     */
    public abstract void set(int i, Object o);
}
